# Generated by Django 3.0 on 2020-02-13 04:22

import django.contrib.postgres.fields
import django.contrib.postgres.fields.jsonb
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
    ]

    operations = [
        migrations.CreateModel(
            name='Mine',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('graph_seed', models.PositiveIntegerField()),
                ('value_seed', models.PositiveIntegerField()),
                ('cost_seed', models.PositiveIntegerField()),
                ('density', models.DecimalField(decimal_places=3, max_digits=4)),
                ('graph', django.contrib.postgres.fields.jsonb.JSONField(null=True)),
            ],
        ),
        migrations.CreateModel(
            name='Solution',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=200, unique=True)),
                ('path', models.FilePathField(path='/home/ben/secrets/mine-solutions', unique=True)),
                ('author', models.CharField(max_length=200, null=True)),
                ('division', models.CharField(max_length=200, null=True)),
            ],
        ),
        migrations.CreateModel(
            name='Result',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('ehp', models.PositiveIntegerField()),
                ('time', models.PositiveIntegerField()),
                ('output', models.TextField()),
                ('score', models.DecimalField(decimal_places=4, max_digits=5)),
                ('error', models.CharField(max_length=200, null=True)),
                ('mine', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='mines.Mine')),
                ('solution', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='mines.Solution')),
            ],
        ),
        migrations.CreateModel(
            name='Quarry',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('graph_seeds', django.contrib.postgres.fields.ArrayField(base_field=models.PositiveIntegerField(), size=10)),
                ('value_seeds', django.contrib.postgres.fields.ArrayField(base_field=models.PositiveIntegerField(), size=10)),
                ('cost_seeds', django.contrib.postgres.fields.ArrayField(base_field=models.PositiveIntegerField(), size=10)),
                ('densities', django.contrib.postgres.fields.ArrayField(base_field=models.DecimalField(decimal_places=3, max_digits=4), size=10)),
                ('mines', models.ManyToManyField(to='mines.Mine')),
            ],
        ),
        migrations.AddConstraint(
            model_name='mine',
            constraint=models.UniqueConstraint(fields=('graph_seed', 'value_seed', 'cost_seed', 'density'), name='unique-mine'),
        ),
        migrations.AddConstraint(
            model_name='result',
            constraint=models.UniqueConstraint(fields=('mine', 'solution', 'ehp', 'time'), name='unique-result'),
        ),
    ]
